#ifndef _CGAL_OBJECT_H_
#define _CGAL_OBJECT_H_

#include <CGAL/basic.h>
#include <CGAL/Simple_cartesian.h>
#include <cgal/Point_2.h>
#include <cgal/Bbox_2.h>
#include <CGAL/Polygon_2.h>
#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <list>
#include <gl/gl.h>


#include "Constant.h"


//typedef CGAL::Simple_cartesian<double>								K;
typedef CGAL::Exact_predicates_inexact_constructions_kernel			K;

typedef CGAL::Polygon_2<K>											Polygon_2;
typedef CGAL::Point_2<K>											Point_2;
typedef CGAL::Bbox_2												BBox_2;


//////////////////////////////////////////////////////////////////////////


class CGAL_Object
{
public:
	CGAL_Object(void);
	virtual ~CGAL_Object(void);

	virtual void Clear() = 0;
	virtual void Draw() = 0;
	virtual void BuildDisplayListObject() = 0;

	virtual void ComputeGeometryParameters(const std::list<std::list<Point_2>>& polygons);

public:
	GLuint  m_nDisplayListObject;

	BBox_2  m_bbox;;
	Point_2 m_center;
	float   m_fFitScale;
};

#endif