
/*
* Copyright (c) 2007, Shenyang Institute of Automation, Chinese Academy
* of Sciences. , all rights reserved.
* 
* Filename     : OpenGLView.h
* Project	   : xMesh library
* Abstract     : Interface for the COpenGLView class
* Version      : 1.0
* Author			: , nanlliang@sia.cn
* Original Author   : , nanlliang@sia.cn
* Accomplished date : Dec. 29, 2007
*/

//-----------------------------------------------------------------


#if !defined _OPENGLVIEW_H_
#define _OPENGLVIEW_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <gl/glut.h>

class COpenGLView : public CView
{	
public:	
	virtual void RenderSceneScalable();			// ƿŵ
	virtual void RenderSceneUnScalable();		// Ʋŵ壬 

	void EnableLighting(bool b);   
	void EnableShowAxises(bool b);
	void ViewFitAll(); 

	void ViewPosTop();
	void ViewPosBottom();
	void ViewPosFront();
	void ViewPosBack();
	void ViewPosLeft();
	void ViewPosRight();
	void ViewPosTrimetric();

protected:
	COpenGLView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(COpenGLView)
		
	// Attributes
public:	
	int        m_nStatus;      

protected:
	HGLRC      m_hRC;	     
	HDC        m_hDC;
	CClientDC* m_pDC;

	GLuint m_nAxisesList;		
	
	int    m_nDisplayMode;     
	bool   m_bEnableLight;    
	bool   m_bShowAxises;

	bool   m_bLeftButtonDown;
	bool   m_bRightButtonDown;
	CPoint m_ptLeftPrevDownPos;
	CPoint m_ptRightPrevDownPos;
	
	GLfloat m_xRotation;
	GLfloat m_yRotation;
	GLfloat m_zRotation;
	
	GLfloat m_xTranslation;
	GLfloat m_yTranslation;
	GLfloat m_zTranslation;
	
	GLfloat m_Scaling;

	GLfloat m_SpeedScaling;
	GLfloat m_SpeedTranslation;
	GLfloat m_SpeedRotation;
	
	// ɫ;
	GLfloat m_BackColorRed;
	GLfloat m_BackColorGreen;
	GLfloat m_BackColorBlue;
	GLfloat m_BackAlpha;
	
	// ת;
	GLfloat m_StepRotationX;
	GLfloat m_StepRotationY;
	GLfloat m_StepRotationZ;

	// ƽͶӰ
	GLfloat m_OrthoRangeLeft;
	GLfloat m_OrthoRangeRight;
	GLfloat m_OrthoRangeTop;
	GLfloat m_OrthoRangeBottom;
	GLfloat m_OrthoRangeNear;
	GLfloat m_OrthoRangeFar;

	// ע"X, Y, Z"
	int m_nFontOffset;
	
	// Operations
protected:
	virtual void InitializeRContext();
	virtual void SetUpDrawingEnvironment();

	void InitGeometry(); //ʼģ͵ʾ

	void PrintAxisLabel(const char* str);	 // ע"X, Y, Z"ĸ
	void PrepareAxisLabel();

	void BuildAxisesList();					 // ʾб

	
	// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(COpenGLView)
public:
protected:
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL
	
	// Implementation
protected:
	virtual ~COpenGLView();
	
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif
	
	// Generated message map functions
protected:
	//{{AFX_MSG(COpenGLView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined _OPENGLVIEW_H_
