#pragma once

#include "MeshSegmentation.h"

// COperationView form view
class CSegmentationDoc;
class CSegmentationView;

class COperationView : public CFormView
{
	DECLARE_DYNCREATE(COperationView)
public:
	CSegmentationView*   m_pDrawView;
	CSegmentationDoc*    m_pDoc;

	void SetRegionDimension(double width, double height);

private:

	//////////////////////////////////////////////////////////////////////////
	// stl ָ
	bool  m_bShowSTLModel;
	bool  m_bShowFeatureEdges;
	bool  m_bShowSegmentation;

	FeatureCriterion	m_featureCriteria;
	float				m_featureEdgeRatio;
	float				m_featureEdgeDihedral;

	//////////////////////////////////////////////////////////////////////////
	// ָ
	double m_dRegionBBoxWidth;
	double m_dRegionBBoxHeight;


	// straight skeleton
	bool   m_bShowContour;
	bool   m_bShowInnerSkeleton;
	bool   m_bShowContourSkeleton;
	
	bool   m_bShowAllOffset;

	double m_dOffset;

	// polygon delaunay graph
	bool   m_bShowPolygonDelaunayGraph;

	double m_dNarrowAreaWidthThreshold;
	bool   m_bShowNarrowAreas;

	unsigned int m_nWhichOffsetContourToShow;



	bool	m_bInitiallized;

protected:
	COperationView();           // protected constructor used by dynamic creation
	virtual ~COperationView();

public:
	enum { IDD = IDD_DIALOG_OPERATION_VIEW };
#ifdef _DEBUG
	virtual void AssertValid() const;
#ifndef _WIN32_WCE
	virtual void Dump(CDumpContext& dc) const;
#endif
#endif

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate();

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButtonSegmentationApply();
	afx_msg void OnBnClickedRadioFeatureEdgeRatio();
	afx_msg void OnBnClickedRadioFeatureEdgeDihedral();
	afx_msg void OnBnClickedCheckShowFeatureEdges();
	afx_msg void OnBnClickedCheckShowCloredResult();
	afx_msg void OnBnClickedButtonCreateInnerSkeleton();
	afx_msg void OnBnClickedButtonCreateOffset();
	afx_msg void OnBnClickedCheckShowContour();
	afx_msg void OnBnClickedCheckShowInnerSkeleton();
	afx_msg void OnBnClickedRadioShowAllOffset();
	afx_msg void OnBnClickedRadioShowSpecifiedOffset();
	afx_msg void OnBnClickedCheckShowContourSkeleton();
	afx_msg void OnBnClickedCheckShowDelaunayGraph();
	afx_msg void OnBnClickedCheckShowNarrowAreas();
	afx_msg void OnBnClickedButtonCreatePolygonDelaunayGraph();
	afx_msg void OnBnClickedButtonDetectNarrowArea();
	afx_msg void OnEnChangeEditWhichOffsetToShow();
};


