// Point2D.h: interface for the Point2D class.

/*
* Copyright (c) 2007, Shenyang Institute of Automation, Chinese Academy
* of Sciences. , all rights reserved.
* 
* Filename     : Point2D.h
* Project	   : xMesh library
* Abstract     : Declaration of Point2D class
* Version      : 1.0
* Author			: , nanlliang@sia.cn
* Original Author   : , nanlliang@sia.cn
* Accomplished date : Dec. 29, 2007
*/

//-----------------------------------------------------------------
#pragma once

class Vector2D;
class Point2D
{
public:
	Point2D();
	Point2D(double _x, double _y);
	Point2D(double* p);
	Point2D(const Point2D& p);
	Point2D(const Vector2D& v);
	~Point2D() {};	

	void   SetValue(double _x, double _y);
	void   SetValue(const Point2D& p);
	void   SetValue(const Vector2D& v);
	void   SetZero();

	void   SetX(double _x);
	void   SetY(double _y);

	double GetX() const;
	double GetY() const;

	double DistanceTo(const Point2D& p) const;
	//double DistanceTo(const Plane& plane) const;

	Point2D  Origin();
	Vector2D Vector() const;

	void operator=(const Point2D& p);

	Point2D operator+(const Vector2D& v) const;
	Point2D operator-(const Vector2D& v) const;
	Point2D operator*(const double s) const;
	Point2D operator/(const double s) const;

	void operator+=(const Vector2D& v);
	void operator-=(const Vector2D& v);
	void operator*=(const double s);
	void operator/=(const double s);

	double  operator [] (const int i) const;
	double& operator [] (const int i);

	bool operator <(const Point2D &p) const;
	bool operator ==(const Point2D &p) const;

public:
	double x;
	double y;
};
