#include "StdAfx.h"
#include "RegionExtracter.h"

RegionExtracter::RegionExtracter(void)
{
}

RegionExtracter::~RegionExtracter(void)
{
}

void RegionExtracter::ExtractRegions(const std::list<std::list<Point_2> > &polygons, Regions &regions)
{
	std::list< PolygonPtr >     outer_contours;   // 
	std::list< PolygonPtr >     inner_contours;   // 
	// polygonsΪࣺ(ʱ)(˳ʱ)	
	ClassifyToOuterAndInner(polygons, outer_contours, inner_contours);

	// ֳһϵжÿһ  һһ	
	MakeRegionsFormContours(outer_contours, inner_contours, regions);
}


void RegionExtracter::ClassifyToOuterAndInner(const std::list<std::list<Point_2>>& polygons, 
											   std::list<PolygonPtr>& outer_contours, 
											   std::list<PolygonPtr>& inner_contours)
{
	std::list< std::list<Point_2> >::const_iterator cur = polygons.begin();
	std::list< std::list<Point_2> >::const_iterator end  = polygons.end();

	for (; cur!=end; ++cur) {
		// ע⣺ еĵһSTLģͰΧжǡʵ෴
		CGAL::Orientation o = CGAL::orientation_2(cur->rbegin(), cur->rend());
		if (o == CGAL::COUNTERCLOCKWISE)
			outer_contours.push_back(PolygonPtr( new Polygon2(cur->rbegin(), cur->rend()) ));
		else if (o == CGAL::CLOCKWISE) 
			inner_contours.push_back(PolygonPtr( new Polygon2(cur->rbegin(), cur->rend()) ));		
	}
}


// ֳһϵжÿһ  һһ	
void RegionExtracter::MakeRegionsFormContours(std::list<PolygonPtr>& all_outer_contours, 
											  std::list<PolygonPtr>& all_inner_contours,
											  Regions &regions)
{
	if (all_outer_contours.empty())
		return;

	std::list<PolygonPtr>  mostOuterContours;
	GetMostOuterContours(all_outer_contours, mostOuterContours);
	std::list<PolygonPtr>  mostInnerContours;
	GetMostOuterContours(all_inner_contours, mostInnerContours);

	/////////////////////////////////////////////////////////////////////////////////

	// mostOuterContoursеÿһmostInnerContoursҵӦµRegion
	std::list<PolygonPtr>::iterator curOuter = mostOuterContours.begin();
	std::list<PolygonPtr>::iterator endOuter = mostOuterContours.end();
	for (; curOuter!=endOuter; ++curOuter)
	{
		std::list<PolygonPtr>  corrospondingInnerContours;

		std::list<PolygonPtr>::iterator curInner = mostInnerContours.begin();
		std::list<PolygonPtr>::iterator endInner = mostInnerContours.end();
		for (; curInner!=endInner; ++curInner)
		{
			PolygonPtr B = *curOuter;
			PolygonPtr A = *curInner;

			if (IsPolygonAInB(A, B))
				corrospondingInnerContours.push_back(A);
		}

		RegionPtr region( new Region() );
		region->push_back(*curOuter);

		std::list<PolygonPtr>::iterator curFoundedInner = corrospondingInnerContours.begin();
		std::list<PolygonPtr>::iterator endFoundedInner = corrospondingInnerContours.end();
		for (; curFoundedInner!=endFoundedInner; ++curFoundedInner)
			region->push_back(*curFoundedInner);

		// ¼
		regions.push_back(region);

		////////////////////////////////////////////////////////////////////////////
		// ɾҵ
		all_outer_contours.erase( std::find(all_outer_contours.begin(), all_outer_contours.end(), *curOuter) );
		// ɾҵ
		for (curFoundedInner = corrospondingInnerContours.begin(); curFoundedInner!=endFoundedInner; ++curFoundedInner)
		{
			all_inner_contours.erase( std::find(all_inner_contours.begin(), all_inner_contours.end(), *curFoundedInner));
			mostInnerContours.erase( std::find(mostInnerContours.begin(), mostInnerContours.end(), *curFoundedInner));
		}
	}

	MakeRegionsFormContours(all_outer_contours, all_inner_contours, regions);
}

// all_contoursҵЩκڲ
// ĿֻһҲжfounded_contours
void RegionExtracter::GetMostOuterContours(std::list<PolygonPtr>& all_contours, 
											std::list<PolygonPtr>& founded_contours)
{
	if (!founded_contours.empty())
		founded_contours.clear();

	if (all_contours.empty())
		return;

	//////////////////////////////////////////////////////////////////////////	

	std::list<PolygonPtr>::iterator cur = all_contours.begin();
	std::list<PolygonPtr>::iterator end = all_contours.end();

	for (; cur!=end; ++cur)
	{
		bool find = true;

		std::list<PolygonPtr>::iterator c = all_contours.begin();
		std::list<PolygonPtr>::iterator e = all_contours.end();
		for (; c!=e; ++c) {
			PolygonPtr A = *cur;
			PolygonPtr B = *c;
			if ( A != B ) {
				if (IsPolygonAInB(A, B))
					find = false;
			}
		}

		if (find)
			founded_contours.push_back(*cur);
	}
}

bool RegionExtracter::IsPolygonAInB(const PolygonPtr& A, const PolygonPtr& B)
{
	if (A == B)
		return false;

	Polygon2::const_iterator cur_A = A->begin();
	Polygon2::const_iterator end_A = A->end();

	for (; cur_A != end_A; ++cur_A)	{
		if ( CGAL::ON_BOUNDED_SIDE == CGAL::bounded_side_2( B->begin(), B->end(), *cur_A ) )
			return true;	
	}

	return false;
}