// SegmentationDoc.h : CSegmentationDoc Ľӿ
//


#pragma once

#include "TriMesh.h"
#include "PolygonSet.h"
#include "StraightSkeleton.h"
#include "PolygonDelaunayGraph.h"
#include "MeshSegmentation.h"

#include <string>
#include <list>


class COperationView;
class CSegmentationView;

class CSegmentationDoc : public CDocument
{
protected: // л
	CSegmentationDoc();
	DECLARE_DYNCREATE(CSegmentationDoc)

// 
public:
	CSegmentationView*  GetDrawView() const;
	COperationView*     GetOperationView() const;

	void ReadPolygonData(std::string file_name);

// 
public:
	TriMesh*						 m_pTriMesh;
	MeshSegmentation				 m_segmentation;	

	PolygonSet						 m_polygonSet;
	StraightSkeleton				 m_straightSkeleton;
	PolygonDelaunayGraph			 m_polygonDelaunayGraph;

private:
	std::string CString2StdString(CString str) const;
	void  ClearAllData();
	void  SetWindowTitle(CString title) const;

// ʵ
public:
	virtual ~CSegmentationDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ɵϢӳ亯
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnFileImportContours();
	afx_msg void OnFileImportStl();
};


