
/*
* Copyright (c) 2007, Shenyang Institute of Automation, Chinese Academy
* of Sciences. , all rights reserved.
* 
* Filename     : Triangle.h
* Project	   : xMesh library
* Abstract     : Interface for the Triangle class
* Version      : 1.0
* Author			: , nanlliang@sia.cn
* Original Author   : , nanlliang@sia.cn
* Accomplished date : Dec. 29, 2007
*/

//-----------------------------------------------------------------

#pragma once
#include "Point3D.h"
#include "Vector3D.h"

class Triangle
{
public:
	Triangle() {};
	Triangle(const Triangle &tri);
	Triangle(const Point3D& v0, const Point3D& v1, const Point3D& v2);
	Triangle(const Point3D& v0, const Point3D& v1, const Point3D& v2, const Vector3D& nor);
	virtual ~Triangle() {};

	double Area() {
		Vector3D BA(vertices[1], vertices[0]);
		Vector3D CA(vertices[2], vertices[0]);
		return (BA * CA).Length() * 0.5;
	}

	//øƬXYZСֵ
	inline double GetMinX()const { return min(vertices[0].GetX(), min(vertices[1].GetX(), vertices[2].GetX())); }
	inline double GetMinY()const { return min(vertices[0].GetY(), min(vertices[1].GetY(), vertices[2].GetY())); }
	inline double GetMinZ()const { return min(vertices[0].GetZ(), min(vertices[1].GetZ(), vertices[2].GetZ())); }
	inline double GetMaxX()const { return max(vertices[0].GetX(), max(vertices[1].GetX(), vertices[2].GetX())); }
	inline double GetMaxY()const { return max(vertices[0].GetY(), max(vertices[1].GetY(), vertices[2].GetY())); }
	inline double GetMaxZ()const { return max(vertices[0].GetZ(), max(vertices[1].GetZ(), vertices[2].GetZ())); }	

	//operator
	const Triangle& operator=(const Triangle& tri);	
	bool operator ==(const Triangle& tri) const;
	bool operator <(const Triangle& tri) const;
	Point3D operator [](const int i) const;
	Point3D& operator [](const int i);

public:
	Point3D  vertices[3];
	Vector3D normal;
};
